%global pkg sfc
%global kernel 5.10.134-18.an8
%define pkg_version 5.3.16.1004
%define anolis_release 1

%global debug_package %{nil}

Name:        kmod-%{pkg}
Version:     %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:     %{pkg_version}~%{anolis_release}%{?dist}
Summary:     BROADCOM MPI3MR Kernel Module Package
License:     GPL-2.0
URL:         https://www.broadcom.cn/products/storage/host-bus-adapters/sas-nvme-9600-16i
Source0:     kmod-%{pkg}-%{pkg_version}.tar.gz

# 安装依赖, 和内核版本对应
Requires:            kernel >= %{kernel}
Requires:   kmod
Requires(posttrans): %{_sbindir}/depmod
Requires(postun):    %{_sbindir}/depmod
Requires(posttrans): %{_sbindir}/weak-modules
Requires(postun):    %{_sbindir}/weak-modules
Requires(posttrans): %{_bindir}/sort
Requires(postun):    %{_bindir}/sort

# 构建依赖, 和内核版本对应
BuildRequires:    kernel-devel   = %{kernel}
BuildRequires:    kernel-headers = %{kernel}
BuildRequires:    elfutils-libelf-devel
BuildRequires:    gcc
BuildRequires:    kmod
BuildRequires:    make
BuildRequires:    system-rpm-config

Provides: kmod-%{pkg}-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-%{pkg}-%{kernel}.%{_arch} < %{version}-%{release}

%description
This is a Kernel Module Package for the BROADCOM MPI3MR driver.

# prep字段无需修改，保持不变即可
%prep
%setup -q -n kmod-%{pkg}-%{pkg_version}

%build
%{__make} -C src KDIR=/usr/src/kernels/%{kernel}.%{_arch} KVER=%{kernel}.%{_arch} modules
#pushd src
#%{__make} -C /usr/src/kernels/%{kernel}.%{_arch} %{?_smp_mflags} M=$PWD modules
#popd

%install
mkdir -p %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/drivers/net/ethernet/sfc
%{__install} -D -t %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/drivers/net/ethernet/sfc src/drivers/net/ethernet/sfc/sfc.ko
%{__install} -D -t %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/drivers/net/ethernet/sfc src/drivers/net/ethernet/sfc/sfc_driverlink.ko
mkdir -p "%{buildroot}/lib/udev/rules.d"
%{__install} -D -t %{buildroot}/lib/udev/rules.d udev/75-xilinx.rules
mkdir -p "%{buildroot}/lib/sfc"
%{__install} -D -t %{buildroot}/lib/sfc/ udev/produce-representor-name.sh
%{__install} -D -t %{buildroot}/lib/sfc/ udev/trigger-representors.sh

# install的该段需要保留，weak-module相关
# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

# Generate depmod.conf
%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%clean
%{__rm} -rf %{buildroot}

%post
if [ -x /etc/hotplug/pci.rc ]; then
	/etc/hotplug/pci.rc start >/dev/null
fi
modprobe sfc

udevadm control --reload
true

depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/drivers/net/ethernet/sfc/sfc_driverlink.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/drivers/net/ethernet/sfc/sfc.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi

%preun
echo "/lib/modules/%{kernel}.%{_arch}/extra/drivers/net/ethernet/sfc/%{pkg}.ko" >> /var/run/rpm-%{pkg}-modules.list

echo "/lib/modules/%{kernel}.%{_arch}/extra/drivers/net/ethernet/sfc/sfc_driverlink.ko" >> /var/run/rpm-%{pkg}-modules.list

%postun
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{pkg}-modules.list


%files
%license licenses
/lib/modules/%{kernel}.%{_arch}
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf

%dir /lib/udev/rules.d/
%dir /lib/sfc/
%dir /lib/modules/%{kernel}.%{_arch}/extra/drivers/net/ethernet/sfc
/lib/udev/rules.d/75-xilinx.rules
/lib/sfc/produce-representor-name.sh
/lib/sfc/trigger-representors.sh

%changelog
* Mon Jul 22 2024 shengaoya <shengaoya@inspur.com> - 5.3.16.1004
- init sfc spec (shengaoya)

